#!/usr/bin/env python

import os, sys, base64

VERSIONEER_b64 = """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"""
newver = "0.20.1"


def main():
    if len(sys.argv) < 2:
        print("Usage: versioneer install")
        sys.exit(1)

    command = sys.argv[1]
    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)

    if command != "install":
        print("Usage: versioneer install")
        sys.exit(1)

    v = base64.b64decode(VERSIONEER_b64.encode('ASCII'))
    if os.path.exists("versioneer.py"):
        for line in open("versioneer.py").readlines()[:5]:
            if line.startswith("# Version: "):
                oldver = line[len("# Version: "):].strip()
                if oldver != newver:
                    print("replacing old versioneer.py (%s)" % oldver)
                break
        else:
            print("overwriting existing versioneer.py")
    with open("versioneer.py", "wb") as f:
        f.write(v)
    print("versioneer.py (%s) installed into local tree" % newver)
    print("Now running 'versioneer.py setup' to install the generated files..")
    if " " in sys.executable:
        import subprocess  # Do not import unless absolutely necessary to avoid compatibility issues
        subprocess.call([sys.executable, "versioneer.py", "setup"])
    else:
        os.execl(sys.executable, sys.executable, "versioneer.py", "setup")

if __name__ == '__main__':
    main()
